/*
 * Copyright 2009 Funambol, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* $Id$ */

#pragma once

#include "Errors.h"
#include "treemanager/MOTreeItemisedCommand.h"

namespace NS_DM_Client
{
    class MOTreeAddCommand : public MOTreeItemisedCommand
    {
    public:
        MOTreeAddCommand(ProfileComponentsHolder* prholder,
						 AddPtr& cmd,
						 const String& msgID,
                         const char* serverId = 0);
        virtual ~MOTreeAddCommand(void);

		virtual bool Execute();

    protected:
        virtual Funambol::ArrayList* getListOfItems();

		AddPtr m_AddCommand;

    private:
        MOTreeAddCommand(const MOTreeAddCommand&);
        MOTreeAddCommand& operator =(const MOTreeAddCommand&);

        StatusCode performOperation();

        StatusCode processAddOnMultipleItems(Funambol::ArrayList* items, IMOTreeManager* treeManager);
        StatusCode processAddOnFUMOMultipleItems(Funambol::ArrayList* items, IMOTreeManager* treeManager);

        StatusCode perocessAddOnFUMO(const char *uri, Funambol::Item &item);
    };
}
